import java.io.IOException;
import java.util.Vector;


/**
 * verarbeitet, liest .... auch leeres startverzeichnis
 * addet nur, wenn datei im pfad gefunden wird
 * schreibt lightbox2 konforme html dateien aus,
 * im style der gallery, dateien enthalten keywords
 * aus den bild(datei)namen
 * @author TET
 * @created 2007-12-21
 * @date 	2008-01-23
 * @version v.0.19
 */
public class GalleryEngine {
	/** kennung fr beginn neuer abschnitt */
	private static String breakerStart = "<!-- GET IT START IT /-->";
	/** kennung fr ende alter abschnitt */
	private static String breakerEnd = "<!-- THIS IS THE END /-->";
	/** domain die als text verwendet werden soll */
	private String domain = null;
	private String indexName = null;
	private String htmlEnd = null;
	private String temp = "";
	private String dateiPfad = "";
	private String dateiName = "";		
	private String ausgangsPfad = "";
	private String dateiNameDanach = "";
	private String ausgangsPfadDanach = "";	
	private String nachricht[] = null;
	private int columnField = 0;	
	/** anzahl spalten */
	private static int columnMax = 5;
	/** anzahl zeile pro datei */
	private int bilderAnzahl=0;
	/** dateigre */
	private long bufferSize=0;
	private long anzahlByte = 0;
	/** main builder */
	private StringBuilder sb = null;
	/** keyword builder */
	private StringBuilder sbKeywords = null;
	/** menue builder */
	private StringBuilder sbMenue = null;
	/** objekteigener fred */
	private Thread reader = null;
	/** Dateiliste die gelesen wird */
	private Vector<?> dateien = null;
	/** Dateiliste die gelesen wird */
	private Vector<MISC_IndexHelper> pfade = null;
	/** absoluter pfad */
	private String superPath = null;
	/** relativer pfad */
	private String subPath = null;
	/** io helferlein */
	private MISC_IO io = null;
	/** index helferlein */
	private MISC_IndexHelper minime = null;
	/** 
	 * @param pfadi - lokaler hauptpfad
	 * @param domain - domain auf der spter gehostet wird
	 * @param dateiName - start bei "index"
	 * @param dateiEndung - endet mit ".html"*/
	public GalleryEngine(String pfadi, String myDomain, String myFile, String myEnd){
		reader = new Thread(pfadi);
		reader.start();	
		superPath=pfadi;
		domain=myDomain;
		indexName=myFile;
		htmlEnd=myEnd;
		io = new MISC_IO(superPath);
	}
	/**
	 * liest die relativen pfade ein
	 * @param bildpfad
	 * @return anzahl der dateien
	 */
	public String[] startDoingIT(String bildpfad){	
		this.subPath=bildpfad;
		nachricht = io.readGrafics( this.subPath );
		dateien = io.sammelalleDateipfade( breakerStart, breakerEnd );
		if (nachricht[0]== null || nachricht[1]== null){
			nachricht[0]="Es wurden " + dateien.size() + " Dateien gelesen.";
			nachricht[1]="There were " + dateien.size() + " Files to read.";
			nachricht[2]=String.valueOf(dateien.size());
		}
		return nachricht;
	}
	/**
	 * holt anhand des indexes, die datei aus der map und
	 * packt diese in einen vector fr die erstellung von
	 * menue und index datei
	 */
	private void collectPathesandPieces(){
		this.pfade = new Vector<MISC_IndexHelper>();	
		this.sbKeywords = new StringBuilder();
		String nochmal ="";
		int bildCounter=0;
		for (int x=0;x<dateien.size();x++) {			
			dateiPfad =(String)dateien.get(x);	
			dateiName = dateiPfad.substring(MISC_Tool.sucheZeichengibStelle(dateiPfad,'\\'),dateiPfad.length() );
			dateiNameDanach=dateiPfad.substring(subPath.length(),(dateiPfad.length()-dateiName.length()) );
			dateiNameDanach=MISC_Tool.removeOnereplacewithOther(dateiNameDanach,'\\','.');
			/* nachfolgendes objekt*/
			try {
				ausgangsPfadDanach = (String)dateien.get(x+1);
				ausgangsPfad = ausgangsPfadDanach.substring(0,MISC_Tool.sucheZeichengibStelle(ausgangsPfadDanach,'\\'));				
				nochmal =ausgangsPfadDanach.substring(subPath.length(),ausgangsPfadDanach.length());
				nochmal =MISC_Tool.removeOnereplacewithOther(nochmal,'\\','.');				
			} catch (IndexOutOfBoundsException ioobe){
				nochmal=dateiNameDanach;
			}
			if (dateiPfad.equalsIgnoreCase(breakerEnd)){
				minime = new MISC_IndexHelper();
				minime.setInhalt(sbKeywords.toString());
				minime.setPfad(temp);		
				minime.setIndex(bildCounter-1);
				pfade.add(minime);
				bildCounter=0;
				sbKeywords.delete(0,sbKeywords.length());
			}
			if (dateiPfad.equalsIgnoreCase(breakerStart) && !(ausgangsPfadDanach.equalsIgnoreCase(breakerStart))){
				sbKeywords.append( nochmal +",");
				bildCounter++;
				temp=nochmal;
			}
			if (!(dateiPfad.equalsIgnoreCase(breakerStart)) && !(dateiPfad.equalsIgnoreCase(breakerEnd))){				
				if (!(ausgangsPfadDanach.equalsIgnoreCase(breakerEnd))) { 					
					sbKeywords.append(nochmal+",");		
					bildCounter++;
					temp=dateiNameDanach;
				}
				if ((ausgangsPfadDanach.equalsIgnoreCase(breakerEnd))) {
					bildCounter++;
					temp=dateiNameDanach;
				}
			}
		}
	}
	/**
	 * erstellt die "Flyer.sitemap.xml"
	 */
	public void createSitemapXML(){
		sb = new StringBuilder();	
		sb.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
		sb.append(" <urlset xmlns=\"http://www.google.com/schemas/sitemap/0.84\">\n");
		sb.append("  <url>\n");
		sb.append("   <loc>");
		sb.append(domain+"/");
		sb.append("</loc>\n");
		sb.append("   <lastmod>");
		sb.append(MISC_Times.gibAktuellesXMLDatum());
		sb.append("</lastmod>\n");
		sb.append("   <changefreq>weekly</changefreq>\n");
		sb.append("   <priority>1.0</priority>\n");
		sb.append("  </url>\n");
		sb.append("  <url>\n");
		sb.append("   <loc>");
		sb.append(domain+"/"+subPath.substring(1,subPath.length())+"."+indexName+htmlEnd);
		sb.append("</loc>\n");
		sb.append("   <lastmod>");
		sb.append(MISC_Times.gibAktuellesXMLDatum());
		sb.append("</lastmod>\n");
		sb.append("   <changefreq>weekly</changefreq>\n");
		sb.append("   <priority>1.0</priority>\n");
		sb.append("  </url>\n");
		/* list all html files */
		for (int i=0; i<pfade.size();i++){
			minime=pfade.get(i);
			sb.append("  <url>\n");
			sb.append("   <loc>");
			sb.append(domain+"/"+subPath.substring(1,subPath.length())+"."+minime.getPfad()+htmlEnd);
			sb.append("</loc>\n");
			sb.append("   <lastmod>");
			sb.append(MISC_Times.gibAktuellesXMLDatum());
			sb.append("</lastmod>\n");
			sb.append("   <changefreq>weekly</changefreq>\n");
			sb.append("   <priority>0.9</priority>\n");
			sb.append("  </url>\n");
		}
		sb.append(" </urlset>\n");
		io.schreibeDatenausStringBuilder(subPath.substring(1,subPath.length())+".sitemap.xml",sb,1);
	}
	/**
	 * open the phys. file with the filename
	 */
	private String openFile(int schalter){
		String dateiNameLang = "";
		try { /* "index." + path + ".html"*/				
			dateiNameDanach=ausgangsPfadDanach.substring(subPath.length(),ausgangsPfadDanach.length());
			dateiNameDanach=MISC_Tool.removeOnereplacewithOther(dateiNameDanach,'\\','.');
			this.createKeyWords(dateiNameDanach);	
			if (schalter == 1){
				dateiNameLang = this.subPath.substring(1,subPath.length())+"."+dateiNameDanach+htmlEnd;
			}
			if (schalter == 2){
				dateiNameLang = this.subPath.substring(1,subPath.length())+"."+indexName+htmlEnd;
			}			
			temp=dateiNameLang;
			io.openit( dateiNameLang );	// open the phys.file
		} catch (IOException e) {
			MISC_Tool.playSoundError(2);
			nachricht[0]="Beim schreiben der Datei " +dateiNameLang+" ist folgender Fehler aufgetreten:\n"+e.toString();
			nachricht[1]="The writing of the file " +dateiNameLang+" results the error :\n"+e.toString();
		}
		return dateiNameLang;
	}
	/**
	 * erstellt die index.html mit den links des menue
	 * @return nachricht bei misserfolg
	 */
	public String[] createIndexHTML(  int breite, int hoehe ){
		sb = new StringBuilder();	
		sbKeywords = new StringBuilder();
		StringBuilder sbTemp = new StringBuilder();
		this.openFile(2);
		/* menue erstellung vorher, wegen keywords */	
		sbTemp.append("     <td colspan=\"2\" class=\"content\">\n");
		sbTemp.append("      <p class=\"content\">");
		sbTemp.append( indexName.substring(0, indexName.length()-1) );
		sbTemp.append("</p>\n");
		sbTemp.append("       <table border=\"0\">\n");
		sbTemp.append("        <tr>\n");
		for (int i=0; i<pfade.size();i++){
			minime=pfade.get(i);
			if (minime.getPfad().length()>=1) {
				sbTemp.append("         <div class=\"pics\"><a href=\"");
				sbTemp.append( this.subPath.substring(1,subPath.length())+"."+this.minime.getPfad()+this.htmlEnd );
				sbTemp.append("\" class=\"menubutton\"><img src=\"images/gallery.icon.logo.ico\" border=\"0\"> ");
				sbTemp.append( this.minime.getPfad().substring(0,minime.getPfad().length()-1) );
				sbTemp.append(" <img src=\"images/gallery.icon.logo.ico\" border=\"0\"></div></a>");
				sbTemp.append("<div class=\"contentadd\"> [ ");
				sbTemp.append( MISC_Tool.machTausenderzeichen(String.valueOf(minime.getIndex())) );
				sbTemp.append(" pieces ] </div>\n");
				this.sbKeywords.append( this.minime.getPfad().substring(0,minime.getPfad().length()-1)+ " , " );
			}
			sbTemp.append("         <br>\n");
		}
		sbTemp.append("        </tr>\n");
		sbTemp.append("       </table>");
		minime = new MISC_IndexHelper();	//
		minime.setIndex( bilderAnzahl );
		/* now the header */
		this.createHeader( dateiName , this.subPath.substring(1,subPath.length())+"."+this.minime.getPfad()+this.htmlEnd );
		this.save();
		sb=sbTemp;
		this.save();
		this.createrFooter( temp );
		anzahlByte += io.closeit();
		return nachricht;
	}


	/**
	 * sammelt aus der dateiliste die inhalte und baut daraus
	 * ein lightbox2.html file (css &co mssen im pfad dann sein)
	 * @param breite - vorschau
	 * @param hoehe - vorschau
	 * @return nachricht - ber die ausgefhrte arbeit (eventuell fehlermeldung)
	 */
	public String[] createSubFolderHTML( int breite, int hoehe ){
		sb = new StringBuilder();			
		String dateiNameLang = "";	//maybe doubled ?		
		for (int x=0;x<dateien.size();x++) {
			ausgangsPfad =(String)dateien.get(x);	
			dateiName = ausgangsPfad.substring(MISC_Tool.sucheZeichengibStelle(ausgangsPfad,'\\'),ausgangsPfad.length() );
			/* read following object  */
			try {
				dateiNameDanach = (String)dateien.get(x+1);
				ausgangsPfadDanach = dateiNameDanach.substring(0,MISC_Tool.sucheZeichengibStelle(dateiNameDanach,'\\'));
			} catch (IndexOutOfBoundsException ioobe){ }			
			/* file creation */
			if ( ausgangsPfad.equals(breakerStart) ){				
				sbKeywords=new StringBuilder();
				if (dateien.size()>(x+1)){
					dateiNameLang = this.openFile(1);				
					this.createHeader( "/"+ausgangsPfadDanach , dateiNameLang );
					sb.append("      <td colspan=\"2\" class=\"content\">\n");
					sb.append("       <p class=\"content\">");
					sb.append( dateiNameDanach.substring(0,dateiNameDanach.length()-1) );
					sb.append("</p>\n");
					sb.append("       <table border=\"0\">\n");
					sb.append("        <tr>\n");
					this.save();
				}
			} /* close file if over */	
			if ( ausgangsPfad.equals(breakerEnd) ){							
				sb.append("       </tr>\n");
				sb.append("      </table>\n");
				sb.append("      <br>\n");	
				this.save();
				this.createrFooter(dateiNameLang);
				anzahlByte += io.closeit();
				columnField=0;
			} /* build the lightboxed table */
			if ( !ausgangsPfad.equals(breakerEnd) && !ausgangsPfad.equals(breakerStart) ) {
				this.createLightboxedTable( breite, hoehe);
				this.save();
			}
		}		
		if (anzahlByte==bufferSize){ // path + 1 cause index.html added there too
			nachricht[0] = (pfade.size()+1 + " HTML-Datei(en) mit " +bilderAnzahl+ " Bildern enthalten: " +
					MISC_Tool.machTausenderzeichen(String.valueOf(bufferSize))+ " Byte(s)");
			nachricht[1] = (pfade.size()+1 + " HTML-File(s) with " +bilderAnzahl+ " Pictures needs: " +
					MISC_Tool.machTausenderzeichen(String.valueOf(bufferSize))+ " Byte(s)");
		}
		return nachricht;
	}

	/**
	 * build the tabledata fr the lightbox overview table, from subfolders
	 * @param width - for thumbnailing
	 * @param height - for thumbnailing 
	 * @param x - position in index list
	 */
	private void createLightboxedTable(int width, int height){
		ausgangsPfad = MISC_Tool.removeOnereplacewithOther(ausgangsPfad,'\\','/');
		columnField++;					// counter for col
		bilderAnzahl++;					// counter for pieces of pics
		sb.append("          <td colspan=\"2\"><div class=\"pics\"><a href=\"");
		sb.append( ausgangsPfad );
		sb.append("\" rel=\"lightbox[roadtrip]\" title=\"");
		sb.append( ausgangsPfad ); 		// title for lightbox.js
		sb.append("\"><img src=\"");
		sb.append( ausgangsPfad ); 		// picsource for lightbox.js
		sb.append("\" width=\"");
		sb.append( width );
		sb.append("\" height=\"");
		sb.append( height );
		sb.append("\" alt=\"");
		sb.append( ausgangsPfad ); 		// for lightbox.js mausover text
		sb.append("\" border=\"0\"></div><div class=\"contentadd\">");	//zeilenumbruch fr beschriftung
		sb.append( dateiName ); 		//dateiname (bildtext)
		sb.append("</a></div></td>\n");
		if ( (columnField%columnMax)==0){ // table row inserter . new line
			sb.append("        ");
			for (int d=0;d<columnMax;d++){
				sb.append("</tr><tr>");
			}
			sb.append("\n");
			columnField=0;
		}
	}
	/**
	 * creates keywords from filename an collect them in a stringbuilder
	 * @param dateiNameNeu
	 */
	private void createKeyWords( String dateiNameNeu ){
		for (int i =0;i<pfade.size();i++){
			minime=pfade.get(i);
			if (minime.getPfad().equalsIgnoreCase(dateiNameNeu)){
				sbKeywords.append(minime.getInhalt().substring(0,minime.getInhalt().length()-1));
				i=pfade.size();
			}
		}
	}
	/**
	 * erstellt fr die html seite den header
	 * @param ausgangsPfad
	 */
	private void createHeader(String ausgangsPfad, String dateiName){
		ausgangsPfad = MISC_Tool.removeOnereplacewithOther(ausgangsPfad,'\\','/');
		sb.append("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN \n");
		sb.append("\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n");
		sb.append("<html xmlns=\"http://www.w3.org/1999/xhtml\" lang=\"en\">\n");
		sb.append(" <head>\n");	
		sb.append("  <meta name=\"generator\" content=\"LightBox2GalleryMaker\">\n");
		sb.append("  <meta http-equiv=\"pragma\" content=\"no-cache\">\n");
		sb.append("  <meta http-equiv=\"cache-control\" content=\"no-cache\">\n");
		sb.append("  <meta http-equiv=\"expires\" content=\"0\">\n");
		sb.append("  <meta name=\"robots\" content=\"index,follow\">\n");
		sb.append("  <meta name=\"revisit-after\" content=\"1 days\">\n");
		sb.append("  <meta name=\"page-topic\" content=\"Content Project\">\n");
		sb.append("  <meta name=\"page-type\" content=\"Homepage\">\n");
		sb.append("  <meta name=\"audience\" content=\"Alle\">\n");
		sb.append("  <meta name=\"author\" content=\"Lightbox 2 Gallery Maker\">\n");			
		sb.append("  <script src=\"js/prototype.js\" type=\"text/javascript\"></script>\n");
		sb.append("  <script src=\"js/scriptaculous.js?load=effects\" type=\"text/javascript\"></script>\n");
		sb.append("  <script src=\"js/lightbox.js\" type=\"text/javascript\"></script>\n");
		sb.append("  <link rel=\"stylesheet\" href=\"css/gallerystyle.css\" type=\"text/css\">\n");
		sb.append("  <link rel=\"stylesheet\" href=\"css/lightbox.css\" type=\"text/css\" media=\"screen\">\n");
		sb.append("  <link rel=\"shortcut icon\" href=\"images/gallery.icon.logo.ico\" type=\"image/x-icon\">\n");
		// dyn start
		sb.append("  <meta name=\"date\" content=\"" + MISC_Times.gibAktuellesHTMLDatum() +"\">\n");
		sb.append("  <meta name=\"publisher\" content=\"" +domain+ "\">\n");
		sb.append("  <meta name=\"copyright\" content=\"" +domain+ "\">\n");
		sb.append("  <meta name=\"siteinfo\" content=\"" +domain+"/"+ "robots.txt\">\n");
		sb.append("  <meta http-equiv=\"keywords\" content=\"" + sbKeywords.toString() +"\">\n");
		sb.append("  <meta http-equiv=\"description\" content=\"" + domain + ausgangsPfad + "\">\n");
		sb.append("  <title>" + this.domain + ausgangsPfad + "</title>\n");
		// dyn end
		sb.append(" </head>\n");
		sb.append(" <body>\n");	
		sb.append("  <h1>"); 
		sb.append( this.subPath.substring(1,subPath.length()) + " Gallerie vom " + MISC_Times.gibAktuellesDatum() );
		sb.append("  </h1>\n");
		sb.append("  <table class=\"ContentContainer\" align=\"center\" width=\"90%\" ");
		sb.append("cellpadding=\"0\" cellspacing=\"0\">\n");
		sb.append("   <tr>\n");
		sb.append("    <td colspan=\"2\" class=\"header\">\n");
		sb.append("     " +MISC_Tool.machTausenderzeichen(String.valueOf(minime.getIndex()))+ " Pics/Files\n");
		sb.append("    </td>\n");
		sb.append("   </tr>\n");
		/* erstelltes menu einbaun */
		sb.append( this.sbMenue.toString() );
		this.save();
	}	
	/**
	 * erstellt das menue auf die kommenden links
	 * @param dateiName - index.
	 * @param dateiEndung - html
	 */
	public void createMenue(){
		this.collectPathesandPieces();
		String dateiNameLang ="";
		sbMenue=new StringBuilder();
		sbMenue.append("   <tr>\n");
		sbMenue.append("    <td class=\"menu\" width=\"200\">\n");
		sbMenue.append("     <br>\n");
		sbMenue.append("      <div class=\"menubutton\"><a href=\"");
		sbMenue.append(  this.subPath.substring(1,subPath.length())+"."+this.indexName+this.htmlEnd );
		sbMenue.append("\"><img src=\"images/gallery.index.menue.jpg\" border=\"0\" width=\"200\" height=\"150\" alt=\"Gallery Index\">");
		sbMenue.append("</a></div>\n");
		sbMenue.append("      <br>\n");		
		for (int i = 0;i<pfade.size();i++){ 		// absuchen von links 
			minime=pfade.get(i);			
			if (minime.getPfad().length()>=1) {
				dateiNameLang = this.subPath.substring(1,subPath.length())+"."+this.minime.getPfad()+this.htmlEnd;
				sbMenue.append("      <div class=\"menubutton\"><a href=\"");
				sbMenue.append( dateiNameLang );
				sbMenue.append("\" class=\"menubutton\"><img src=\"images/gallery.icon.logo.ico\" border=\"0\"> ");
				sbMenue.append( this.minime.getPfad().substring( 0 , this.minime.getPfad().length()-1) );
				sbMenue.append(" <img src=\"images/gallery.icon.logo.ico\" border=\"0\"> </a></div>\n");
			}
		}
		sbMenue.append("      <br>\n");
		sbMenue.append("      <div class=\"menubutton\">\n");
		sbMenue.append("       <object data=\"images/gallery.logo.menue.swf\" type=\"application/x-shockwave-flash\" width=\"200\" height=\"200\">\n");
		sbMenue.append("        <param name=\"movie\" value=\"images/gallery.logo.menue.swf\">\n");
		sbMenue.append("        <param name=\"quality\" value=\"high\">\n");
		sbMenue.append("        <param name=\"scale\" value=\"exactfit\">\n");
		sbMenue.append("        <param name=\"menu\" value=\"true\">\n");
		sbMenue.append("        <param name=\"bgcolor\" value=\"#000000\">\n");
		sbMenue.append("       </object>\n");
		sbMenue.append("      </div>\n");
		sbMenue.append("     </td>\n");
	}
	/**
	 * erstellt den unteren teil der html datei (footer)
	 */
	private void createrFooter(String dateiNameLang){
		sb.append("     <p class=\"links\"><a href=\""+this.domain+"/"+dateiNameLang+"\" class=\"link\">"+this.domain+"/"+dateiNameLang+"</a></p>\n");
		sb.append("    </td>\n");
		sb.append("   </tr>\n");
		sb.append("   <tr>\n");
		sb.append("    <td colspan=\"2\" class=\"footer\">made with <a href=\"http://www.goashake.de/stuff/lightbox2.gallery.maker.zip\"><b>Lightbox 2 Gallery Maker</b></a> [ v.");
		sb.append( Lightbox2_GalleryMaker.getVersion() );
		sb.append(" ] by <a href=\"http://www.goashake.de\">www.goashake.de</a>");
		sb.append(" based on <a href=\"http://www.huddletogether.com/projects/lightbox2/\">Lightbox JS</a> by Lokesh Dhakar</td>\n");
		sb.append("   </tr>\n");
		sb.append("  </table>\n");
		sb.append(" </body>\n");
		sb.append("</html>\n");
		this.save();
	}
	/**
	 * schreibt zeile in datei (physikalisch)
	 * zhlt die zeilen 1+
	 * zhlt die dateigre mit
	 * lscht den stringbuilder auf leer
	 */
	private void save(){
		sb.trimToSize();
		if (sb.length()>0){
			io.writeit(sb);
			bufferSize+=sb.length();
		}
		sb.delete(0,sb.length());		
	}
	public static String getBreakerStart() {
		return breakerStart;
	}
	public static String getBreakerEnd() {
		return breakerEnd;
	}
}