
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.TreeMap;
import java.util.Vector;

/**
 * subklasse die zum datenhandling benutzt wird <BR>
 * datei einlesen <BR>
 * datei schreiben aus : <BR>
 * 	1. StringBuilder - in einem Rutsch<BR>
 *  2. StringBuilder - on demand<BR>
 * @author TET<BR>
 * @created 2006-06-11<BR>
 * @date 	2007-12-31<BR>
 * @version v.0.44<BR>
 */
public class MISC_IO {
	/**
	 * der objectfred
	 */
	private Thread ioio;
	/**
	 * dateiliste (pfade) fr den ersten durchlauf 
	 */
	private Vector<String[]> dateiListe = new Vector<String[]>();
	/**
	 * hilfsobjekt fr die dateiname
	 */
	private LinkedList<MISC_IndexHelper> dateiIndex = new LinkedList<MISC_IndexHelper>();
	/**
	 * vector fr die pfade, die durchsucht werden sollen, wchst whrend der suche an
	 */
	private Vector<String> Pfade = new Vector<String>();
	/**
	 * dass file
	 */
	private File userFile  = null;
	/**
	 * die dateiinhalte aus einer gelesenen datei 
	 */
	private Vector<String> dateiInhalte = null;
	/**
	 * map fr die listen - objectunique
	 */
	private TreeMap<String,String> dateiListen = null;
	/**
	 * vector fr das ausschreiben der daten
	 */
	private Vector<String> geleseneDateien = null;
	/**
	 * writer fr die datei
	 */
	private PrintWriter out = null;
	/**
	 * dateiname
	 */
	private String dateiName = null;
	private String masterPath = null;
	private String bildPfad = null;
	/**
	 * hilfsobject fr die inhalten & den index
	 */
	private MISC_IndexHelper minime = null;
	/**
	 * counter fr die dateigre in byte
	 */
	private long counter = 0;
	
	/**
	 * kontruktor startet thread mit pfad als namen
	 * @param pfad
	 */
	public MISC_IO(String pfad) {
		this.masterPath=pfad;
		ioio = new Thread(pfad);
		ioio.start();
	}
	/**
	 * liet aus den dateien der dateiliste, die inhalte zeilenweise aus
	 * und packt diese als string in einen vector
	 * @param dateiname
	 */
	public void liesDateiTXT_V(String dateiname) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(dateiname));
			dateiInhalte = new Vector<String>();
			StringBuilder zeile = new StringBuilder();
			String line = "";
			while ( (line=br.readLine())!=null )
			{zeile.append(line);}
			br.close();
			zeile.trimToSize();
			dateiInhalte.add(zeile.toString());
			System.out.println("aus Datei " + dateiname + " wurden " + dateiInhalte.size() + " Daten gelesen");
		}
		catch ( FileNotFoundException fnfe)
		{dateiInhalte = new Vector<String>();}
		catch ( IOException ioe)
		{dateiInhalte = new Vector<String>();}
	}	
	/**
	 * erstellt eine datei, lscht vorgnger, falls vorhanden
	 * bentigt wird dann noch :
	 * public void writeit(StringBuilder sb)
	 * public void closeit()
	 * @param dateiname
	 * @throws IOException
	 */
	public void openit(String dateiname)throws IOException{
		dateiName=dateiname;
		counter=0;
		File Datensatz = new File(dateiName);		
		if (Datensatz.exists())	{
			Datensatz.delete();
		}
		Datensatz.createNewFile();
		if (!Datensatz.canWrite()){
			System.out.println("Datensatz schreibgeschtzt");
			return ;
		}
		out = new PrintWriter(new FileOutputStream(Datensatz));			
	}
	/**
	 * schreibt mit printwriter den stringbuilder
	 * vorher muss 
	 * public void openit(String dateiname)throws IOException
	 * ausgefhrt sein, anschlieend 
	 * public void closeit()
	 * @param sb
	 */
	public void writeit(StringBuilder sb){
		counter+=sb.length();
		out.println(sb);
	}
	/**
	 * schliet einen/den stream, dann die datei und berichtet
	 */
	public long closeit(){
		out.flush();
		out.close();
		return counter;
	}
	/**
	 * erstellt eine datei, lscht vorgnger, falls vorhanden
	 * schreibt aus einem stringbuilder in die datei
	 * schliet stream und datei, berichtet dann
	 * @param dateiname pfad+dateiname
	 * @param obj stringbuilder der geschrieben werden soll
	 * @param anzahl eventuell kopieren des obj
	 */
	public void schreibeDatenausStringBuilder( String dateiname, StringBuilder obj, long anzahl ) {
		out = null;
		try {
			userFile = new File(dateiname);		
			if (userFile.exists())	{
				userFile.delete();
			}
			userFile.createNewFile();
			if (!userFile.canWrite()){
				System.out.println("Datensatz schreibgeschtzt");
				return ;
			}
			out = new PrintWriter(new FileOutputStream(userFile));			
			for (int x=0;x<anzahl;x++){
				out.print(obj);
			}
			out.flush();
			out.close();
			//System.out.println("Datei " + dateiname + " mit " + (obj.length()*anzahl) + " Byte geschrieben");			
		} catch (IOException e) {System.out.println("Fehler: " + e.toString());}
	}
	
	/**
	 * pfad muss unbedingt berprft werden !!!
	 * datei im pfad einlesen <BR>	 
	 * @param MasterPath
	 * @param subPath
	 * @return nachrichte, falls fehler waren
	 */
	public String[] readGrafics(String subPath ) {
		this.bildPfad=subPath;
		userFile = new File( this.masterPath + this.bildPfad );		
		dateiListen = new TreeMap<String,String>();		
		String[] ebene0 = userFile.list();
		String[] nachricht = this.erstelleUrliste( ebene0 );		
		for (int x = 0; x<this.Pfade.size();x++){
			this.readallPathes( this.Pfade.get(x) );
		}
		return nachricht;
	}
	
	/**
	 * erstellt die initialbefllung aus dem pfad
	 * @param MasterPath
	 * @param subPath
	 * @param ebene0
	 */
	private String[] erstelleUrliste( String [] ebene0 ){
		String[] nachricht=new String[3];
		if (ebene0!=null){
			File newFile = null;		
			String[] daten = null; 
			String nochNPfad = null;
			for (int x = 0; x<ebene0.length;x++){
				newFile = new File( this.masterPath+this.bildPfad+"\\"+ebene0[x] );				
				nochNPfad = this.bildPfad;	//zweigt nochmal ab
				daten = newFile.list();
				if (newFile.isDirectory() && daten!=null){
					nochNPfad+="\\"+ebene0[x];
					if (checkDateiFormat(nochNPfad)==true){					
						for (int l = 0;l<daten.length;l++){	
							if (MISC_Tool.checkDateiendung(daten[l])==false)
								Pfade.add(nochNPfad+"\\"+daten[l]);	
							if (MISC_Tool.checkDateiendung(nochNPfad)==true && newFile.length()>0)
								this.saveIndexed(nochNPfad);
							if (MISC_Tool.checkDateiendung(daten[l])==true && newFile.length()>0)
								this.saveIndexed(nochNPfad+"\\"+daten[l]);
							if (MISC_Tool.checkDateiendung(nochNPfad)==false && MISC_Tool.checkDateiendung(nochNPfad+"\\"+daten[l])==true){
								Pfade.add(nochNPfad);
							}
						}
					}
					if (checkDateiFormat(nochNPfad)==false && MISC_Tool.checkDateiendung(nochNPfad)==false){
						Pfade.add(nochNPfad);						
					}
				}
				if (newFile.isFile() && daten==null && newFile.length()>0){				
					if (checkDateiFormat(nochNPfad)==true && MISC_Tool.checkDateiendung(newFile.getName())==true){
						this.saveIndexed(nochNPfad+"\\"+newFile.getName());
					}
				}
				
			}
		}
		if (ebene0==null){
			nachricht[0]="Der Pfad fr die Rohdaten muss mit "+Lightbox2_GalleryMaker.getRelationalerPfad()+" beginnen\n";
			nachricht[1]="The (sub)Path for the picturedata must start with /pics/";
		}
		return nachricht;
	}
	
	/**
	 * liet pfade, entscheidet ob verzeichnis => pfade.add
	 * wenn datei, dann in den index
	 * @param MasterPath
	 * @param subPath
	 */
	private void readallPathes( String subPath ){
		userFile = new File( this.masterPath + subPath );		
		String[] allet = userFile.list();
		if (allet==null && userFile.isFile()){
			this.saveIndexed(  subPath  );			
		}
		if (allet!=null && userFile.isFile()){			
			this.Pfade.add(subPath);
			for (int x =0; x<allet.length;x++) {
				this.saveIndexed(  subPath+ "\\"+allet[x]  );
			}
		}		
		if (allet!=null && userFile.isDirectory()){			
			for (int x =0; x<allet.length;x++) {
				File temp = new File(this.masterPath + subPath+ "\\" +allet[x]);
				if(MISC_Tool.checkDateiendung( allet[x])==true){
					if (temp.length()>0)
						this.saveIndexed(subPath+ "\\" +allet[x]);	
				}
				if(MISC_Tool.checkDateiendung( allet[x])==false){
					Pfade.add(subPath+"\\"+allet[x]);	
				}			
			}
		}
	}
	
	/**
	 * @param subPath - pfad des sub
	 * @param allet - pfadarray
	 * @return true, wenn gefunden
	 */
	private boolean checkDateiFormat(String subPath){	
		String[] sub = null;
		boolean gefunden = false;
		if (gefunden==false){
			sub=userFile.list( new MISC_gifFilenameFilter() );
			if (sub!=null && sub.length>0)
				gefunden = true;
		}
		if (gefunden==false){
			sub=userFile.list( new MISC_jpgFilenameFilter() );
			if (sub!=null && sub.length>0)
				gefunden = true;			
		}
		if (gefunden==false){
			sub=userFile.list( new MISC_pngFilenameFilter() );
			if (sub!=null && sub.length>0)
				gefunden = true;
		}
		if (gefunden==false){
			sub=userFile.list( new MISC_datFilenameFilter() );
			if (sub!=null && sub.length>0)
				gefunden = true;
		}
		return gefunden;
	}
	
	/**
	 * speichert den index anhand der gre des trees
	 * bsp : saveIndexed("hallo wer da");
	 * minime@dateiIndex=>dateiListe<dateiListen.size, "hallo wer da">
	 * @param inhalt
	 */
	private void saveIndexed(String inhalt){
		if (inhalt!=null){
			if (MISC_Tool.checkDateiendung(inhalt)==true && inhalt.length()>0 ){
				minime = new MISC_IndexHelper();
				inhalt.trim();
				inhalt.toLowerCase();
				minime.setIndex(dateiIndex.size());
				minime.setInhalt(inhalt);
				boolean index = minime.getInhalt().equalsIgnoreCase(dateiListen.get(minime.getInhalt()));
				boolean imtree = dateiListen.containsKey( minime.getInhalt() );
				if ( index==false && imtree==false ) {
					dateiListen.put( minime.getInhalt(),minime.getInhalt() );		
					dateiIndex.add(minime);
				}
			}
		}
	}
	/**
	 * schaut im verzeichnis nach und erstellt eine liste der dateien in einem array <BR>
	 * zur weitere verarbeitung <BR>
	 * subPath bsp: "/PalmDateien/"
	 * @param path - root
	 * @param subPath - subpath von der vm aus gesehen
	 * @param MasterPath - aus System.getProperty();
	 * @return size = anzahl der dateien <BR>
	 */
	public Vector<String> sammelalleDateipfade( String breakerStart, String breakerEnd ) {		
		this.dateiIndex=MISC_Tool.sortiereIndex(this.dateiIndex);
		geleseneDateien = new Vector<String>();
		geleseneDateien.add( breakerStart );
		MISC_IndexHelper minime = null;
		MISC_IndexHelper minime2 = null;
		String wollnwahaben = "";
		String wollnwanich = "";
		for (int z = 0; z<dateiIndex.size();z++){
			try{
				minime=dateiIndex.get(z);
				minime2=dateiIndex.get(z+1);				
				wollnwahaben=dateiListen.get(minime.getInhalt());
				wollnwanich=dateiListen.get(minime2.getInhalt());
				int a = MISC_Tool.sucheZeichengibStelle(wollnwahaben,'\\');
				int b = MISC_Tool.sucheZeichengibStelle(wollnwanich,'\\');
				if (MISC_Tool.checkDateiendung(wollnwahaben)==true){
					// vergleich aktuelle zu nachfolger
					if (!wollnwahaben.substring(0,a).equalsIgnoreCase(wollnwanich.substring(0,b)))
						if (wollnwahaben.startsWith("\\")){
							wollnwahaben=wollnwahaben.substring(1,wollnwahaben.length()); //vorn das / abschnippeln
							geleseneDateien.add( wollnwahaben );	
							geleseneDateien.add( breakerEnd );
							geleseneDateien.add( breakerStart );
						}							
					if (wollnwahaben.substring(0,a).equalsIgnoreCase(wollnwanich.substring(0,b)))
						if (wollnwahaben.startsWith("\\")){
							wollnwahaben=wollnwahaben.substring(1,wollnwahaben.length()); //vorn das / abschnippeln
							geleseneDateien.add( wollnwahaben );	
						}				
				}
				if (MISC_Tool.checkDateiendung(wollnwahaben)==false && MISC_Tool.checkDateiendung(wollnwanich)==true){
					geleseneDateien.add( breakerEnd );
					geleseneDateien.add( breakerStart );
				}
			} catch (IndexOutOfBoundsException ioobe){
				if (MISC_Tool.checkDateiendung(wollnwanich)==true){
					wollnwanich=wollnwanich.substring(1,wollnwanich.length());
					geleseneDateien.add( wollnwanich );	
				}
				geleseneDateien.add( breakerEnd );
			}
		}
		return geleseneDateien;
	}
	/**
	 * @return stingliste ll <BR>
	 */
	public Vector<String> getStringliste() {
		return dateiInhalte;
	}
	/**
	 * @param stringliste ll <BR>
	 */
	public void setStringliste(Vector<String> stringliste) {
		this.dateiInhalte = stringliste;
	}
	class MISC_datFilenameFilter implements FilenameFilter {
		/**
		 * Die Methode(Filter) berprft, die sich im StringArray  <BR>
		 * befindenen Dateien nach dem DateiFormat dat richten <BR>
		 */
		public boolean accept( File f, String s )
		{
			boolean filter = false;
			if (s.toLowerCase().endsWith(".dat"))
				filter = true;
			return filter;
		}
	}
	class MISC_jpgFilenameFilter implements FilenameFilter {
		/**
		 * Die Methode(Filter) berprft, die sich im StringArray  <BR>
		 * befindenen Dateien nach dem DateiFormat jpg richten <BR>
		 */
		public boolean accept( File f, String s )
		{
			boolean filter = false;
			if (s.toLowerCase().endsWith(".jpg"))
				filter = true;
			return filter;
		}
	}
	class MISC_gifFilenameFilter implements FilenameFilter {
		/**
		 * Die Methode(Filter) berprft, die sich im StringArray  <BR>
		 * befindenen Dateien nach dem DateiFormat gif richten <BR>
		 */
		public boolean accept( File f, String s )
		{
			boolean filter = false;
			if (s.toLowerCase().endsWith(".gif"))
				filter = true;
			return filter;
		}
	}
	class MISC_pngFilenameFilter implements FilenameFilter {
		/**
		 * Die Methode(Filter) berprft, die sich im StringArray  <BR>
		 * befindenen Dateien nach dem DateiFormat png richten <BR>
		 */
		public boolean accept( File f, String s )
		{
			boolean filter = false;
			if (s.toLowerCase().endsWith(".png"))
				filter = true;
			return filter;
		}
	}
	class MISC_icoFilenameFilter implements FilenameFilter {
		/**
		 * Die Methode(Filter) berprft, die sich im StringArray  <BR>
		 * befindenen Dateien nach dem DateiFormat png richten <BR>
		 */
		public boolean accept( File f, String s )
		{
			boolean filter = false;
			if (s.toLowerCase().endsWith(".ico"))
				filter = true;
			return filter;
		}
	}
	public Vector<String[]> getDateiListe() {
		return dateiListe;
	}
	
	public void setDateiListe(Vector<String[]> dateiListe) {
		this.dateiListe = dateiListe;
	}
	public Vector<String> getgeleseneDateien() {
		return geleseneDateien;
	}
	public void setgeleseneDateien(Vector<String> geleseneDateien) {
		this.geleseneDateien = geleseneDateien;
	}
}