
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import javax.swing.JComponent;

/**
 * serviceklasse welches eine progressbar / ladebalken in das motherframe  <BR>
 * malt und den ladestatus in prozent angibt <BR>
 * controler - berechnung der prozente in dieser klasse <BR>
 * view - zeichnung der grafik in MISC_ProgressBarTheBar 
 * bergeben werden : <BR>
 * derzeitige positon (i) <BR>
 * gre der schleife (lenth) <BR>
 * intern wird in prozentrechnung umgesetzt, jedoch als int <BR>
 * geparst um technische rundungsfehler zu beheben <BR>
 * @author TET <BR>
 * @version v0.2 <BR>
 */
public class MISC_ProgressBar
{
	private Graphics g = null;
	private MISC_ProgressBarTheBar bar = null;
	private double percent = 0;
	private Thread engine = null;
	private int mLast = 0;
	
	/**
	 * konstruktur der klasse
	 * @param graph (graphic des motherframe)
	 */
	public MISC_ProgressBar( Graphics graph)
	{	
		engine = new Thread(graph.toString());
		engine.start();
		g = graph;
		init();
		updateBar(0,0);		
	}
	/**
	 * initialisieren der inneren klasse, die das eigentliche <BR>
	 * malen der grafik bernimmt <BR>
	 */
	public void init(){
		bar = new MISC_ProgressBarTheBar(percent);
	}
	
	public void updateBar(int pos, int max)	{
		if (pos == 0){
			pos = 1;
			this.mLast = 0;
		}		
		double posx = (double)pos;				// umsetzen von int auf double
		double maxx = (double)max;
		percent = (posx/maxx);					//prozentrechnung
		int dd = (int)Math.round(percent*100);	//runden
		if (this.mLast <= dd)					//wenn einerschritt komplett
		{
			if ((posx+1) >= maxx)	//rundungsfehler - korrektur
			{
				percent = 1;
			}
			percent = (double)dd/100;			//wieder das gerundete zurck kopieren
			//System.out.println(mLast + " " + dd + " " + percent);
			bar.setPercent(percent);
			bar.paintComponent(g);
			this.mLast = dd+1;
		}
	}
}

/**
 * view der komponente <BR>
 * zeichnen der grafik findet hier statt
 *  <BR>
 * die position x/y im motherframe muss derzeit hndisch eingestellt werden <BR>
 * da es abhngig vom endgltigen design der mother ist <BR>
 * @author markus schulz <BR>
 * @version v0.2  <BR>
 */
class MISC_ProgressBarTheBar extends JComponent
{
	private static final long serialVersionUID = 1581153066284447313L;
	private double percent = 0.00; // 0.00 to 1.00
	private int xpos = 136;
	private int ypos = 114;
	private int weite = 442;
	private int hoehe = 14;
	private Rectangle progressBar = new Rectangle(xpos, ypos, weite, hoehe);
	
	/**
	 * konstruktor der klasse
	 * @param prozent
	 */
	public MISC_ProgressBarTheBar(double prozent)
	{
		percent = prozent;
		this.repaint();
	}
	
	/**
	 * repaintfunktion wird hier ausgefhrt,  <BR>
	 * welche aus dem controller gestartet wird <BR>
	 */
	public void paintComponent(Graphics grafik)
	{		
		Graphics2D g = (Graphics2D)grafik;
		super.paintComponent( grafik );
		g.clearRect(xpos, ypos, weite, hoehe);
		g.setColor(Color.DARK_GRAY);
		g.fillRect(progressBar.x, progressBar.y,
				(int)(progressBar.width*percent), progressBar.height);
		g.setColor(Color.BLACK);
		g.drawRect(progressBar.x, progressBar.y, progressBar.width,progressBar.height);		
		g.setColor(Color.GRAY);
		g.setFont(new Font("Tahoma", Font.BOLD , 11));
		g.drawString(nurDreiStellen(), xpos+((weite/2)-12),ypos+((hoehe/2)+4));
	}
	
	/**
	 * formatiert die prozente fr die darstellung im ladebalken <BR>
	 * bsp aus 0.1 wird 10.0%
	 * @return prozent  <BR>
	 */
	public String nurDreiStellen() {
		String dieProzente = "";
		for (int i = 0; i < 3; i++) {
    		dieProzente += String.valueOf(percent*100).charAt(i);
    	}
		dieProzente += "0";
		if (percent == 1.0) {
			dieProzente = "100";
		}
		dieProzente += " %";
		return dieProzente;
	}
	
	/**
	 * externe setzen der member percent <BR>
	 * @param percent <BR>
	 */
	public void setPercent(double percent) {
		this.percent = percent;
	}
}